/* -------------------- main_cli.c -----------------------
 * client using TCP protocol
 */

#include "inet.h"

int main(){
   int sockfd;
   struct sockaddr_in serv_addr;
   char sendline[MAXLINE], recvline[MAXLINE];
   int n;

   /*
    * fill in the structure "serv_addr" with address
    * of server we want to connect with
    */

   /*bzero( (char *) &serv_addr, sizeof(serv_addr));*/
   memset( (char *) &serv_addr, 0, sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = inet_addr(SERV_HOST_ADDR);
   serv_addr.sin_port = htons(SERV_TCP_PORT);

   /*
    * open a TCP socket - internet stream socket
    */
   
   if ( (sockfd = socket(AF_INET, SOCK_STREAM,0)) < 0 ) {
      perror("client: can't open stream socket");
      exit(1);
   }

   /*
    * connect to the server
    */

   if (connect(sockfd, (struct sockaddr *) &serv_addr,
         sizeof(serv_addr) ) < 0) {
      perror("client: can't connect to server");
      exit(2);
   }

   printf("%25s", "Client - give input: ");
   if( fgets(sendline,MAXLINE,stdin) != NULL) {
       n = strlen(sendline);
       if (send(sockfd, sendline,n,0) < n)
           exit(3);
       shutdown(sockfd,1);
       if(recv(sockfd,recvline,n,0) < 0)
           exit(4);
       recvline[n] = '\0';
       printf("%25s%s\n","Client - got: ", recvline);
   }

   close(sockfd);
   exit(0);
}
