/* -------------------- main_cli.c -----------------------
 * client using UDP protocol
 */

#include "inet.h"

int main(int argc, char ** argv){
   int sockfd;
   struct sockaddr_in cli_addr, serv_addr;
   char sendline[MAXLINE], recvline[MAXLINE];
   int n;

   /*
    * fill in the structure "serv_addr" with address
    * of server we want to connect with
    */

   bzero( (char *) &serv_addr, sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = inet_addr(SERV_HOST_ADDR);
   serv_addr.sin_port = htons(SERV_UDP_PORT);

   /*
    * open a UDP socket - internet datagramm socket
    */
   
   if ( (sockfd = socket(AF_INET, SOCK_DGRAM,0)) < 0 ) {
      perror("client: can't open datagramm socket");
      exit(1);
   }

   /* 
    * bind any local address for us
    */
   bzero( (char *) &cli_addr, sizeof(cli_addr));
   cli_addr.sin_family = AF_INET;
   cli_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   cli_addr.sin_port = htons(0);

   if (bind(sockfd, (struct sockaddr *) &cli_addr,
         sizeof(cli_addr)) < 0 ) {
      perror("client: can't bind local address");
      exit(2);
   }

   printf("%25s", "Client - give input: ");
   if( fgets(sendline,MAXLINE,stdin) != NULL) {
       n = strlen(sendline);
       if (sendto(sockfd, sendline,n,0,(struct sockaddr *)&serv_addr, 
                  sizeof(serv_addr)) < n) {
           perror("client - sendto");
           exit(3);
       }
       shutdown(sockfd,1);
       if(( n=recvfrom(sockfd,recvline,n,0,(struct sockaddr *)0, 
                       (int *)0)) < 0) {
           perror("client - recvfrom");
           exit(4);
       }
       recvline[n] = '\0';
       printf("%25s%s\n","Client - got: ", recvline);
   }

   close(sockfd);
   exit(0);
}
