/* main_cli.c
 *
 * client using Unix domain stream protocol
 */

#include "unix.h"

int main() {
   int sockfd, servlen;
   struct sockaddr_un serv_addr;
   char sendline[MAXLINE], recvline[MAXLINE];
   int n;

   /*
    * Fill in the structure "serv_addr" with the
    * address of the server that we want to sent do
    */
   bzero( (char *) &serv_addr, sizeof(serv_addr) );
   serv_addr.sun_family = AF_UNIX;
   strcpy(serv_addr.sun_path, UNIXSTR_PATH);
   servlen = strlen(serv_addr.sun_path) + sizeof(serv_addr.sun_family);

    /*
     * open an Unix domain stream socket
     */
   if ( (sockfd = socket(AF_UNIX, SOCK_STREAM, 0) ) < 0) {
      perror("client: can't open stream socket");
      exit(1);
   }

   /*
    * connect to the server
    */
   if (connect(sockfd, (struct sockaddr *) &serv_addr, servlen) < 0) {
      perror("client: can't connect to server");
      exit(1);
   }

   printf("%25s", "Client - give input: ");
   while ( fgets(sendline,MAXLINE,stdin) != NULL) {
       n = strlen(sendline);
       if (send(sockfd, sendline,n,0) < n)
           exit(3);
       if(recv(sockfd,recvline,n,0) < 0)
           exit(4);
       recvline[n] = '\0';
       printf("> %s\n", recvline);
   }


   close(sockfd);
   exit(0);
}
