#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

void print_netent(struct netent * np) {
	char ** ptr;

	printf("Offizieller Netzwerk-Name: %s\n", np->n_name);

	for(ptr = np->n_aliases; ptr && *ptr; ptr++)
		printf("   Alias: %s\n", *ptr);

	printf("   Adresstyp: %d\n", np->n_addrtype);
	printf("   Netzwerk-Nummer: %s\n", inet_ntoa(inet_makeaddr(np->n_net, 0)));
}

int main(int argc, const char **argv) {
	struct netent *np;

	if (argc != 2) {
		fprintf(stderr, "usage: %s network\n", argv[0]);
		exit (1);
	}

	np = getnetbyname(argv[1]);
	if (np == NULL) {
		fprintf(stderr, "getnetbyname() failed for %s\n", argv[1]);
		exit (2);
	}

	print_netent(np);

	exit (0);
}
