#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

void print_protoent(struct protoent * pp) {
	char ** ptr;

	printf("Offizieller Protokoll-Name: %s\n", pp->p_name);

	for(ptr = pp->p_aliases; ptr && *ptr; ptr++)
		printf("   Alias: %s\n", *ptr);

	printf("   Protokoll-Nummer: %d\n", pp->p_proto);
}

int main(int argc, const char **argv) {
	struct protoent *pp;

	if (argc != 2) {
		fprintf(stderr, "usage: %s protocol#\n", argv[0]);
		exit (1);
	}

	pp = getprotobynumber(atoi(argv[1]));
	if (pp == NULL) {
		fprintf(stderr, "getprotobynumber() failed for %s\n", argv[1]);
		exit (2);
	}

	print_protoent(pp);

	exit (0);
}
