#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

void print_servent(struct servent * sp) {
	char ** ptr;

	printf("Offizieller Service-Name: %s\n", sp->s_name);

	for(ptr = sp->s_aliases; ptr && *ptr; ptr++)
		printf("   Alias: %s\n", *ptr);

	printf("   Port: %d\n", ntohs(sp->s_port));
	printf("   Protokoll: %s\n", sp->s_proto);
}

int main(int argc, const char **argv) {
	struct servent *sp;

	if (argc != 3) {
		fprintf(stderr, "usage: %s service protocol\n", argv[0]);
		exit (1);
	}

	sp = getservbyname(argv[1], argv[2]);
	if (sp == NULL) {
		fprintf(stderr, "getservbyname() failed for %s and %s\n", argv[1], argv[2]);
		exit (2);
	}

	print_servent(sp);

	exit (0);
}
